# Class ModelScene

#### Hierarchy

- Scene
  - ModelScene

- Defined in lib/five/model/model-scene.ts:102
- Defined in lib/five/model/model-scene.ts:119

##### Index

### Constructors

constructor

### Properties

autoRefine
boundingBox
boundingMesh
fiveId
loaded
models
needsRender
parameter
refined
refineProgress

### Accessors

bounding
empty

### Methods

addEventListener
dispatchEvent
dispose
getMaterial
intersectRaycaster
removeEventListener
resetBrightness
setMaterial
setModels
update

## Constructors

### constructor

- new ModelScene(options: { fiveId: string }): ModelScene

  #### Parameters

  - options: { fiveId: string }

  #### Returns ModelScene

  - Defined in lib/five/model/model-scene.ts:151

## Properties

### autoRefine

autoRefine: boolean = true

自动细化

- Defined in lib/five/model/model-scene.ts:125

### boundingBox

boundingBox: Box3 = ...

包围盒

- Defined in lib/five/model/model-scene.ts:128

### boundingMesh

boundingMesh: BoundingMesh

包围盒 Mesh

- Defined in lib/five/model/model-scene.ts:131

### fiveId

fiveId: string

- Defined in lib/five/model/model-scene.ts:121

### loaded

loaded: boolean = false

加载完成

- Defined in lib/five/model/model-scene.ts:134

### `Readonly` models

models: Models

模型列表

- Defined in lib/five/model/model-scene.ts:146

### needsRender

needsRender: boolean = true

- Defined in lib/five/model/model-scene.ts:122

### parameter

parameter: Parameter = ...

参数

- Defined in lib/five/model/model-scene.ts:143

### refined

refined: boolean = false

细化完成

- Defined in lib/five/model/model-scene.ts:137

### refineProgress

refineProgress: [number, number] = ...

细化进度

- Defined in lib/five/model/model-scene.ts:140

## Accessors

### bounding

- get bounding(): Box3

  #### Returns Box3

  #### Deprecated

  Use `.boundingBox` instead

  - Defined in lib/five/model/model-scene.ts:474

### empty

- get empty(): boolean

  #### Returns boolean

  - Defined in lib/five/model/model-scene.ts:322

## Methods

### addEventListener

- addEventListener(
  type: "model.create",
  listener: (event: Event & { model: Model; type: "model.create" }) => void,
  ): void

  #### Parameters

  - type: "model.create"
  - listener: (event: Event & { model: Model; type: "model.create" }) => void

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:108
- addEventListener(
  type: "model.dispose",
  listener: (event: Event & { model: Model; type: "model.dispose" }) => void,
  ): void

  #### Parameters

  - type: "model.dispose"
  - listener: (event: Event & { model: Model; type: "model.dispose" }) => void

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:109
- addEventListener(type: string, listener: (event: Event) => void): void

  #### Parameters

  - type: string
  - listener: (event: Event) => void

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:110

### dispatchEvent

- dispatchEvent(event: { model: Model; type: "model.create" }): void

  #### Parameters

  - event: { model: Model; type: "model.create" }

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:104
- dispatchEvent(event: { model: Model; type: "model.dispose" }): void

  #### Parameters

  - event: { model: Model; type: "model.dispose" }

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:105
- dispatchEvent(event: { type: string; [attachment: string]: any }): void

  #### Parameters

  - event: { type: string; [attachment: string]: any }

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:106

### dispose

- dispose(): void

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:505

### getMaterial

- getMaterial(): ParameterValue

  #### Returns ParameterValue

  #### Deprecated

  Use `.parameter.get` instead

  - Defined in lib/five/model/model-scene.ts:490

### intersectRaycaster

- intersectRaycaster(
  raycaster: Raycaster,
  target?: Intersection[],
  ): Intersection[]

  计算模型射线碰撞检测

  #### Parameters

  - raycaster: Raycaster

    THREE 射线对象

  - `Optional` target: Intersection[]

    返回碰撞点

  #### Returns Intersection[]

  返回碰撞点

  - Defined in lib/five/model/model-scene.ts:332

### removeEventListener

- removeEventListener(
  type: "model.create",
  listener: (event: Event & { model: Model; type: "model.create" }) => void,
  ): void

  #### Parameters

  - type: "model.create"
  - listener: (event: Event & { model: Model; type: "model.create" }) => void

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:112
- removeEventListener(
  type: "model.dispose",
  listener: (event: Event & { model: Model; type: "model.dispose" }) => void,
  ): void

  #### Parameters

  - type: "model.dispose"
  - listener: (event: Event & { model: Model; type: "model.dispose" }) => void

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:113
- removeEventListener(type: string, listener: (event: Event) => void): void

  #### Parameters

  - type: string
  - listener: (event: Event) => void

  #### Returns void

  - Defined in lib/five/model/model-scene.ts:114

### resetBrightness

- resetBrightness(): void

  #### Returns void

  #### Deprecated

  Use `.parameter.reset('brightness')` instead

  - Defined in lib/five/model/model-scene.ts:498

### setMaterial

- setMaterial(parameter: Partial<ParameterValue>): void

  #### Parameters

  - parameter: Partial<ParameterValue>

  #### Returns void

  #### Deprecated

  Use `.parameter.set` instead

  - Defined in lib/five/model/model-scene.ts:482

### setModels

- setModels(works: Works, options: ModelOptions): Model[]

  #### Parameters

  - works: Works
  - options: ModelOptions

  #### Returns Model[]

  - Defined in lib/five/model/model-scene.ts:230

### update

- update(renderer: WebGLRenderer, camera: Camera): boolean

  #### Parameters

  - renderer: WebGLRenderer
  - camera: Camera

  #### Returns boolean

  - Defined in lib/five/model/model-scene.ts:351